From 4a9f6c215fb3fefc360ac0fc5d196e2064a4a3c4 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 13 2017 11:23:17 +0000
Subject: [PATCH 747/1001] Use the validators's return value for the widget conf


The validators were returning a converted value (for example, to
integer) but that value was ignored and the widgets had to do the
conversion again themselves when they wanted to use that value.

This changeset make use of the validators to convert to and from the
string that was passed to the config form.

---

diff --git a/hubs/validators.py b/hubs/validators.py
index e065629..b59ca25 100644
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -6,56 +6,101 @@ import hubs.models
 import requests
 
 
-def required(session, value):
-    if bool(value):
+class Validator(object):
+
+    @classmethod
+    def from_string(cls, value):
+        if value is None:
+            return ""
         return value
 
+    @classmethod
+    def to_string(cls, value):
+        return value
 
-def text(session, value):
-    return kitchen.text.converters.to_unicode(value)
 
+class Required(Validator):
 
-def integer(session, value):
-    return int(value)
+    @classmethod
+    def from_string(cls, value):
+        if not bool(value):
+            raise ValueError("the parameter is required")
+        return value
 
 
-def link(session, value):
-    # TODO -- verify that this is actually a link
-    return value
+class Text(Validator):
 
+    @classmethod
+    def from_string(cls, value):
+        return kitchen.text.converters.to_unicode(value)
 
-def username(session, value):
-    if hubs.models.User.by_username(value) is not None:
-        return value
-    raise ValueError('Invalid username')
 
+class Integer(Validator):
 
-def github_organization(session, value):
-    # TODO -- implement this.
-    return value
+    @classmethod
+    def from_string(cls, value):
+        return int(value)
 
-def github_repo(session, value):
-    # TODO -- implement this.
-    return value
 
+class Link(Validator):
 
-def fmn_context(session, value):
-    # TODO get this from the fedmsg config.
-    if value in [
-        'irc', 'email', 'android', 'desktop', 'hubs',]:
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- verify that this is actually a link
         return value
-    raise ValueError('Invalid FMN context')
 
 
-def pagure_repo(session, value):
-    response = requests.get("https://pagure.io/%s" % value, timeout=5)
-    if response.status_code == 200:
+class Username(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        if hubs.models.User.by_username(value) is not None:
+            return value
+        raise ValueError('Invalid username')
+
+
+class GithubOrganization(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- implement this.
         return value
-    raise ValueError('Invalid pagure repo')
 
 
-def fedorahosted_project(session, value):
-    response = requests.get("https://fedorahosted.org/%s" % value, timeout=5)
-    if response.status_code == 200:
+class GithubRepo(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO -- implement this.
         return value
-    raise ValueError('Invalid fedorahosted project')
+
+
+class FMNContext(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        # TODO get this from the fedmsg config.
+        if value in [
+            'irc', 'email', 'android', 'desktop', 'hubs',]:
+            return value
+        raise ValueError('Invalid FMN context')
+
+
+class PagureRepo(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        response = requests.get("https://pagure.io/%s" % value, timeout=5)
+        if response.status_code == 200:
+            return value
+        raise ValueError('Invalid pagure repo')
+
+
+class FedorahostedProject(Validator):
+
+    @classmethod
+    def from_string(cls, value):
+        response = requests.get("https://fedorahosted.org/%s" % value, timeout=5)
+        if response.status_code == 200:
+            return value
+        raise ValueError('Invalid fedorahosted project')
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 6641711..7b03d57 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -212,7 +212,7 @@ def hub_add_widget_post(name):
             error = True
             break
         try:
-            param.validator(flask.g.db, val)
+            val = param.validator.from_string(val)
             config[param.name] = val
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 192c44d..adc857a 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -48,7 +48,7 @@ def widget_edit_post(hub, idx):
             error = True
             break
         try:
-            val = param.validator(flask.g.db, val)
+            val = param.validator.from_string(val)
             config[param.name] = val
         except Exception as err:
             flask.flash('Invalid data provided, error: %s' % err, 'error')
diff --git a/hubs/widgets/about/__init__.py b/hubs/widgets/about/__init__.py
index bdb7e7b..5fe313c 100644
--- a/hubs/widgets/about/__init__.py
+++ b/hubs/widgets/about/__init__.py
@@ -13,7 +13,7 @@ class About(Widget):
         name="text",
         label="Text",
         default="I am a Fedora user, and this is my about",
-        validator=validators.text,
+        validator=validators.Text,
         help="Text about a user.",
         )]
 
diff --git a/hubs/widgets/badges/__init__.py b/hubs/widgets/badges/__init__.py
index 79315e1..1c102cb 100644
--- a/hubs/widgets/badges/__init__.py
+++ b/hubs/widgets/badges/__init__.py
@@ -16,7 +16,7 @@ class Badges(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index c63fa3c..5717e24 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -19,7 +19,7 @@ class Bugzilla(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/dummy/__init__.py b/hubs/widgets/dummy/__init__.py
index ca4bac8..daa0600 100644
--- a/hubs/widgets/dummy/__init__.py
+++ b/hubs/widgets/dummy/__init__.py
@@ -12,7 +12,7 @@ class Dummy(Widget):
         name="text",
         label="Text",
         default="Lorem ipsum dolor...",
-        validator=validators.text,
+        validator=validators.Text,
         help="Some dummy text to display.",
         )]
 
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index 142548f..4887af8 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -21,7 +21,7 @@ class FedmsgStats(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index b1f8299..9180637 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -17,13 +17,13 @@ class Feed(Widget):
             "name": "username",
             "label": "Username",
             "default": None,
-            "validator": validators.username,
+            "validator": validators.Username,
             "help": "A FAS username.",
         }, {
             "name": "message_limit",
             "label": "Message limit",
             "default": 20,
-            "validator": validators.integer,
+            "validator": validators.Integer,
             "help": "Max number of feed messages to display.",
         }]
 
diff --git a/hubs/widgets/fhosted/__init__.py b/hubs/widgets/fhosted/__init__.py
index 8f60efa..49a7955 100644
--- a/hubs/widgets/fhosted/__init__.py
+++ b/hubs/widgets/fhosted/__init__.py
@@ -16,13 +16,13 @@ class FedoraHosted(Widget):
             name="project",
             label="Project",
             default=None,
-            validator=validators.fedorahosted_project,
+            validator=validators.FedorahostedProject,
             help="Name of the trac instance on fedorahosted.org.",
         ), dict(
             name="n_tickets",
             label="Number of tickets",
             default=4,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="The number of tickets to display.",
         )]
 
@@ -48,7 +48,7 @@ class GetTickets(CachedFunction):
     Queries Fedorahosted via xmlrpc for tickets. '''
 
     def execute(self):
-        n_tickets = int(self.instance.config["n_tickets"])
+        n_tickets = self.instance.config["n_tickets"]
         url = 'https://fedorahosted.org/%s/rpc' \
             % self.instance.config["project"]
         filters = 'status=accepted&status=assigned&status=new&status=reopened'\
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index 6961d4a..d794c24 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -22,13 +22,13 @@ class GitHubPRs(Widget):
             name="organization",
             label="Organization",
             default=None,
-            validator=validators.github_organization,
+            validator=validators.GithubOrganization,
             help="Github Organization or username",
         ), dict(
             name="display_number",
             label="Number of tickets",
             default=6,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="How many pull requests to display at max.",
         )]
 
@@ -42,10 +42,9 @@ class BaseView(WidgetView):
     def get_context(self, instance, *args, **kwargs):
         get_prs = GetPRs(instance)
         org = instance.config["organization"]
-        display_number = int(instance.config["display_number"])
         context = dict(
             organization=org,
-            display_number=display_number,
+            display_number=instance.config["display_number"],
             title="Github: Pull Requests",
         )
         context.update(get_prs())
@@ -56,7 +55,7 @@ class GetPRs(CachedFunction):
 
     def execute(self):
         org = self.instance.config["organization"]
-        display_number = int(self.instance.config["display_number"])
+        display_number = self.instance.config["display_number"]
         log.info("Getting GH prs for %r, (%r)" % (org, display_number))
         token = fedmsg_config.get('github.oauth_token')
         pulls = []
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
index e29faa7..7172dbb 100644
--- a/hubs/widgets/githubissues/__init__.py
+++ b/hubs/widgets/githubissues/__init__.py
@@ -16,19 +16,19 @@ class GitHubIssues(Widget):
             name="org",
             label="Username",
             default=None,
-            validator=validators.github_organization,
+            validator=validators.GithubOrganization,
             help="Github Organization or username",
         ), dict(
             name="repo",
             label="Repository",
             default=None,
-            validator=validators.github_repo,
+            validator=validators.GithubRepo,
             help="Github repository",
         ), dict(
             name="display_number",
             label="Number of tickets",
             default=10,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="The number of tickets to display.",
         )]
 
@@ -44,7 +44,7 @@ class BaseView(WidgetView):
         return dict(
             org=instance.config["org"],
             repo=instance.config["repo"],
-            display_number=int(instance.config["display_number"]),
+            display_number=instance.config["display_number"],
             title="Github: Newest Open Tickets",
             all_issues=get_issues(),
         )
diff --git a/hubs/widgets/library/__init__.py b/hubs/widgets/library/__init__.py
index 351ec4f..bab0ab4 100644
--- a/hubs/widgets/library/__init__.py
+++ b/hubs/widgets/library/__init__.py
@@ -13,7 +13,7 @@ class Library(Widget):
         name="urls",
         label="URLs",
         default=None,
-        validator=validators.text,
+        validator=validators.Text,
         help="A comma separated list of URLs to add to the library. "
              "External links must include the whole link "
              "(starting with http...)."
diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
index dfae632..0da1cb7 100644
--- a/hubs/widgets/linechart/__init__.py
+++ b/hubs/widgets/linechart/__init__.py
@@ -12,7 +12,7 @@ class Linechart(Widget):
         name="username",
         label="Username",
         default=None,
-        validator=validators.username,
+        validator=validators.Username,
         help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
index 01908ce..fbe712a 100644
--- a/hubs/widgets/meetings/__init__.py
+++ b/hubs/widgets/meetings/__init__.py
@@ -20,13 +20,13 @@ class Meetings(Widget):
             name="calendar",
             label="Calendar",
             default=None,
-            validator=validators.required,
+            validator=validators.Required,
             help="A fedocal calendar.",
         ), dict(
             name="n_meetings",
             label="Number of meetings",
             default=4,
-            validator=validators.integer,
+            validator=validators.Integer,
             help="The number of meetings to display.",
         )]
 
@@ -56,7 +56,7 @@ class GetMeetings(CachedFunction):
 
     def execute(self):
         calendar = self.instance.config["calendar"]
-        n_meetings = int(self.instance.config.get("n_meetings", 4))
+        n_meetings = self.instance.config.get("n_meetings", 4)
         base = ('https://apps.fedoraproject.org/calendar/api/meetings/'
                 '?calendar=%s')
         url = base % calendar
diff --git a/hubs/widgets/pagure_pr/__init__.py b/hubs/widgets/pagure_pr/__init__.py
index 518d12d..1ace710 100644
--- a/hubs/widgets/pagure_pr/__init__.py
+++ b/hubs/widgets/pagure_pr/__init__.py
@@ -18,7 +18,7 @@ class PagurePRs(Widget):
             name="repo",
             label="Repository",
             default=None,
-            validator=validators.pagure_repo,
+            validator=validators.PagureRepo,
             help="Pagure repo name.",
         )]
 
diff --git a/hubs/widgets/pagureissues/__init__.py b/hubs/widgets/pagureissues/__init__.py
index 356d59f..f8df811 100644
--- a/hubs/widgets/pagureissues/__init__.py
+++ b/hubs/widgets/pagureissues/__init__.py
@@ -18,7 +18,7 @@ class PagureIssues(Widget):
             name="repo",
             label="Repository",
             default=None,
-            validator=validators.pagure_repo,
+            validator=validators.PagureRepo,
             help="Pagure repo name",
         )]
 
diff --git a/hubs/widgets/rules/__init__.py b/hubs/widgets/rules/__init__.py
index 498e3a8..5c207a3 100644
--- a/hubs/widgets/rules/__init__.py
+++ b/hubs/widgets/rules/__init__.py
@@ -19,25 +19,25 @@ class Rules(Widget):
             name="link",
             label="Link",
             default=None,
-            validator=validators.link,
+            validator=validators.Link,
             help="Link to the community rules and guidelines.",
         ), dict(
             name="schedule_text",
             label="Schedule text",
             default=None,
-            validator=validators.text,
+            validator=validators.Text,
             help="Some text about when meetings are.",
         ), dict(
             name="schedule_link",
             label="Schedule link",
             default=None,
-            validator=validators.link,
+            validator=validators.Link,
             help="Link to a schedule for IRC meetings, etc.",
         ), dict(
             name="minutes_link",
             label="Minutes link",
             default=None,
-            validator=validators.link,
+            validator=validators.Link,
             help="Link to meeting menutes from past meetings.",
         )]
 
diff --git a/hubs/widgets/sticky/__init__.py b/hubs/widgets/sticky/__init__.py
index 3f038ba..3fcccfc 100644
--- a/hubs/widgets/sticky/__init__.py
+++ b/hubs/widgets/sticky/__init__.py
@@ -13,7 +13,7 @@ class Sticky(Widget):
             name="text",
             label="Text",
             default="Lorem ipsum dolor...",
-            validator=validators.text,
+            validator=validators.Text,
             help="Some dummy text to display.",
         )]
 
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index 1641191..b427ad5 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -22,7 +22,7 @@ class Subscriptions(Widget):
             name="username",
             label="Username",
             default=None,
-            validator=validators.username,
+            validator=validators.Username,
             help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 07fd52b..1c926d5 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -17,7 +17,7 @@ class PendingACLs(Widget):
             name="username",
             label="Username",
             default=None,
-            validator=validators.username,
+            validator=validators.Username,
             help="A FAS username.",
         )]
 
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 79fac1f..92a56dd 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -21,7 +21,7 @@ class Updates2Stable(Widget):
             name="username",
             label="Username",
             default=None,
-            validator=validators.username,
+            validator=validators.Username,
             help="A FAS username.",
         )]
 

